/* $LAAS: worker.c 2008/09/15 11:50:01 mallet $ */

/* 
 * Copyright (c) 2008 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 *					Anthony Mallet on Fri Sep 12 2008
 */

static const char _rcsid[] = "$LAAS: worker.c 2008/09/15 11:50:01 mallet $";

#include "stereopixel-config.h"

#if SPIX_THREADS
#include <stdio.h>
#include <err.h>

#include "libstereopixel.h"
#include "workers.h"

void *
spix_worker_thread(void *data)
{
  spix_worker *w = data;
  int s;

  while(1) {
    /* wait for a job */
    pthread_barrier_wait(w->start);

    s = w->job(w->source_gauche, w->source_droite,
	       w->images_gauches, w->images_droites,
	       w->tab_tab_produits, w->somme_pdt_haut, w->somme_pdt_bas,
	       w->tab_scores, w->tab_scores_2, w->tab_max, w->correlation_params,
	       w->correlation_results, w->i_min, w->i_max);

    /* signal job done */
    pthread_barrier_wait(w->done);

    /* wait for restart */
    pthread_barrier_wait(w->reset);
  }

  return NULL;
}

#endif /* SPIX_THREADS */
