/* $LAAS: workers.h 2008/09/14 21:21:00 tho $ */

/* 
 * Copyright (c) 2008 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 *					Anthony Mallet on Fri Sep 12 2008
 */

#ifndef H_SPIX_WORKERS
#define H_SPIX_WORKERS

#include <pthread.h>

typedef struct spix_worker {
  int id;
  pthread_t thread;

  pthread_barrier_t *start, *done, *reset;

  unsigned char *source_gauche, *source_droite;
  SP_IMAGES_TMP *images_gauches, *images_droites;
  SP_CORRELATION_PARAMS *correlation_params;
  SP_CORRELATION_RESULTS *correlation_results;
  void **tab_tab_produits;
  void *somme_pdt_bas;
  void *somme_pdt_haut;
  void *tab_scores;
  void *tab_scores_2;
  int *tab_max;
  int i_min, i_max;

  int (*job)(unsigned char *source_gauche, unsigned char *source_droite,
	     SP_IMAGES_TMP *images_gauches, SP_IMAGES_TMP *images_droites,
	     void **tab_tab_produits, void *sum_products_top,
	     void *sum_products_bot, void *tab_scores, void *tab_scores_2,
	     int *tab_max, SP_CORRELATION_PARAMS *correlation_params,
	     SP_CORRELATION_RESULTS *correlation_results, int i_min, int i_max);

} spix_worker;

void *	spix_worker_thread(void *data);

#endif /* H_SPIX_WORKERS */
